#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include "NvVideoDecoder.h"

pid_t child_pid;

int main(int argc, char** argv)
{
	if(argc > 1 && !strcmp(argv[1],"noFork"))
	{
		printf("Parent(noFork): BEGIN\n");
		void* decPtr = (void*)(NvVideoDecoder::createVideoDecoder("dec0"));
		if(decPtr) printf("Decoder created\n");
		printf("Parent(noFork): END\n");
		return 0;
	}
	else
	{
		int rv = 0;
		printf("Parent: BEGIN\n");
		switch(child_pid=fork())
		{
			case -1:
			{
				printf("fork error\n");
				return 1;
			}
			case 0: //child
			{
				printf("Child: BEGIN\n");
				break;
			}
			default: //parent
			{
				printf("Child PID: %d\n", child_pid);
				wait(&rv);
				if(WIFSIGNALED(rv))
				{
					printf("Child process terminated by signal %d\n", WTERMSIG(rv));
				}
				printf("Parent: END\n");
				return 0;
				break;
			}
		}
	}
	
	sleep(1);
	void* decPtr = (void*)(NvVideoDecoder::createVideoDecoder("dec0"));
	if(decPtr) printf("Decoder created\n");
	printf("Child: END\n");
	
	return 0;
}
